
include:
- template: Jobs/Dependency-Scanning.gitlab-ci.yml

stages:
  - security
  - build
  - test
  - docker-build

dependency_scanning:
  stage: security

build-java-app:
  stage: build
  image: maven:3.6-jdk-11
  script:
    - mvn clean package
  artifacts:
    paths:
      - target/*.jar
  only:
    - develop
    - master
    - merge_requests

test-java-app:
  stage: test
  image: maven:3.6-jdk-11
  dependencies: [build-java-app]
  script:
    - mvn test
    - cat target/site/jacoco/index.html | grep -o '<tfoot>.*</tfoot>'
  artifacts:
    reports:
      junit:
        - target/surefire-reports/*.xml
    
  coverage: "/Total.*?([0-9]{1,3})%./"

  only:
    - develop
    - master
    - merge_requests

build-docker-image:
  stage: docker-build
  image: docker:latest
  services:
    - docker:dind
  variables:
    DOCKER_DRIVER: overlay2
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  only: 
    - master
    - develop